Index: src/test/bfs_test.cc
===================================================================
--- src/test/bfs_test.cc	(revision 986)
+++ src/test/bfs_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/bfs_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/dfs_test.cc
===================================================================
--- src/test/dfs_test.cc	(revision 986)
+++ src/test/dfs_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/dfs_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/dijkstra_heap_test.cc
===================================================================
--- src/test/dijkstra_heap_test.cc	(revision 1139)
+++ src/test/dijkstra_heap_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/dijkstra_heap_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/dijkstra_test.cc
===================================================================
--- src/test/dijkstra_test.cc	(revision 1148)
+++ src/test/dijkstra_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/dijkstra_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/error_test.cc
===================================================================
--- src/test/error_test.cc	(revision 921)
+++ src/test/error_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/error_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/graph_factory_test.cc
===================================================================
--- src/test/graph_factory_test.cc	(revision 986)
+++ src/test/graph_factory_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/graph_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/graph_test.h
===================================================================
--- src/test/graph_test.h	(revision 986)
+++ src/test/graph_test.h	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/graph_test.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/graph_utils_test.h
===================================================================
--- src/test/graph_utils_test.h	(revision 977)
+++ src/test/graph_utils_test.h	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/graph_utils_test.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/graph_wrapper_test.cc
===================================================================
--- src/test/graph_wrapper_test.cc	(revision 1160)
+++ src/test/graph_wrapper_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/graph_wrapper_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/kruskal_test.cc
===================================================================
--- src/test/kruskal_test.cc	(revision 959)
+++ src/test/kruskal_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/kruskal_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/map_test.h
===================================================================
--- src/test/map_test.h	(revision 1041)
+++ src/test/map_test.h	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/map_test.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/max_matching_test.cc
===================================================================
--- src/test/max_matching_test.cc	(revision 1158)
+++ src/test/max_matching_test.cc	(revision 1164)
@@ -3,5 +3,5 @@
  * Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/min_cost_flow_test.cc
===================================================================
--- src/test/min_cost_flow_test.cc	(revision 941)
+++ src/test/min_cost_flow_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/min_cost_flow_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/path_test.cc
===================================================================
--- src/test/path_test.cc	(revision 990)
+++ src/test/path_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/path_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/preflow_test.cc
===================================================================
--- src/test/preflow_test.cc	(revision 986)
+++ src/test/preflow_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/preflow_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/suurballe_test.cc
===================================================================
--- src/test/suurballe_test.cc	(revision 941)
+++ src/test/suurballe_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/suurballe_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/sym_graph_test.cc
===================================================================
--- src/test/sym_graph_test.cc	(revision 986)
+++ src/test/sym_graph_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/sym_graph_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/sym_graph_test.h
===================================================================
--- src/test/sym_graph_test.h	(revision 987)
+++ src/test/sym_graph_test.h	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/sym_graph_test.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/test_tools.h
===================================================================
--- src/test/test_tools.h	(revision 986)
+++ src/test/test_tools.h	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/test_tools.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/test_tools_fail.cc
===================================================================
--- src/test/test_tools_fail.cc	(revision 1149)
+++ src/test/test_tools_fail.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/test_tools_fail.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/test_tools_pass.cc
===================================================================
--- src/test/test_tools_pass.cc	(revision 921)
+++ src/test/test_tools_pass.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/test_tools_pass.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/time_measure_test.cc
===================================================================
--- src/test/time_measure_test.cc	(revision 1069)
+++ src/test/time_measure_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/time_measure_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/unionfind_test.cc
===================================================================
--- src/test/unionfind_test.cc	(revision 921)
+++ src/test/unionfind_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/unionfind_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *
Index: src/test/xy_test.cc
===================================================================
--- src/test/xy_test.cc	(revision 921)
+++ src/test/xy_test.cc	(revision 1164)
@@ -2,5 +2,5 @@
  * src/test/xy_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Combinatorial Optimization Research Group, EGRES).
  *