Index: lemon/capacity_scaling.h
===================================================================
--- lemon/capacity_scaling.h	(revision 2620)
+++ lemon/capacity_scaling.h	(revision 2623)
@@ -256,7 +256,7 @@
                      const SupplyMap &supply ) :
       _graph(graph), _lower(&lower), _capacity(graph), _cost(cost),
-      _supply(graph), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false),
-      _res_cap(graph), _excess(graph), _pred(graph)
+      _supply(graph), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false),
+      _res_cap(graph), _excess(graph), _pred(graph), _dijkstra(NULL)
     {
       // Removing non-zero lower bounds
@@ -289,7 +289,7 @@
                      const SupplyMap &supply ) :
       _graph(graph), _lower(NULL), _capacity(capacity), _cost(cost),
-      _supply(supply), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false),
-      _res_cap(capacity), _excess(graph), _pred(graph)
+      _supply(supply), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false),
+      _res_cap(capacity), _excess(graph), _pred(graph), _dijkstra(NULL)
     {
       // Checking the sum of supply values
@@ -318,7 +318,7 @@
                      Supply flow_value ) :
       _graph(graph), _lower(&lower), _capacity(graph), _cost(cost),
-      _supply(graph), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false),
-      _res_cap(graph), _excess(graph), _pred(graph)
+      _supply(graph), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false),
+      _res_cap(graph), _excess(graph), _pred(graph), _dijkstra(NULL)
     {
       // Removing non-zero lower bounds
@@ -355,7 +355,7 @@
                      Supply flow_value ) :
       _graph(graph), _lower(NULL), _capacity(capacity), _cost(cost),
-      _supply(graph, 0), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false),
-      _res_cap(capacity), _excess(graph), _pred(graph)
+      _supply(graph, 0), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false),
+      _res_cap(capacity), _excess(graph), _pred(graph), _dijkstra(NULL)
     {
       _supply[s] =  flow_value;
Index: lemon/cost_scaling.h
===================================================================
--- lemon/cost_scaling.h	(revision 2620)
+++ lemon/cost_scaling.h	(revision 2623)
@@ -182,8 +182,8 @@
     bool _local_potential;
 
+    // The residual cost map
+    ResidualCostMap<LargeCostMap> _res_cost;
     // The residual graph
     ResGraph *_res_graph;
-    // The residual cost map
-    ResidualCostMap<LargeCostMap> _res_cost;
     // The reduced cost map
     ReducedCostMap *_red_cost;
@@ -210,7 +210,7 @@
                  const SupplyMap &supply ) :
       _graph(graph), _lower(&lower), _capacity(graph), _orig_cost(cost),
-      _cost(graph), _supply(graph), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false), _res_cost(_cost),
-      _excess(graph, 0)
+      _cost(graph), _supply(graph), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false), _res_cost(_cost),
+      _res_graph(NULL), _red_cost(NULL), _excess(graph, 0)
     {
       // Removing non-zero lower bounds
@@ -242,7 +242,7 @@
                  const SupplyMap &supply ) :
       _graph(graph), _lower(NULL), _capacity(capacity), _orig_cost(cost),
-      _cost(graph), _supply(supply), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false), _res_cost(_cost),
-      _excess(graph, 0)
+      _cost(graph), _supply(supply), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false), _res_cost(_cost),
+      _res_graph(NULL), _red_cost(NULL), _excess(graph, 0)
     {
       // Checking the sum of supply values
@@ -271,7 +271,7 @@
                  Supply flow_value ) :
       _graph(graph), _lower(&lower), _capacity(graph), _orig_cost(cost),
-      _cost(graph), _supply(graph), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false), _res_cost(_cost),
-      _excess(graph, 0)
+      _cost(graph), _supply(graph), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false), _res_cost(_cost),
+      _res_graph(NULL), _red_cost(NULL), _excess(graph, 0)
     {
       // Removing nonzero lower bounds
@@ -307,7 +307,7 @@
                  Supply flow_value ) :
       _graph(graph), _lower(NULL), _capacity(capacity), _orig_cost(cost),
-      _cost(graph), _supply(graph, 0), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false), _res_cost(_cost),
-      _excess(graph, 0)
+      _cost(graph), _supply(graph, 0), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false), _res_cost(_cost),
+      _res_graph(NULL), _red_cost(NULL), _excess(graph, 0)
     {
       _supply[s] =  flow_value;
Index: lemon/cycle_canceling.h
===================================================================
--- lemon/cycle_canceling.h	(revision 2620)
+++ lemon/cycle_canceling.h	(revision 2623)
@@ -169,6 +169,7 @@
                     const SupplyMap &supply ) :
       _graph(graph), _lower(&lower), _capacity(graph), _cost(cost),
-      _supply(graph), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false), _res_cost(_cost)
+      _supply(graph), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false), _res_graph(NULL),
+      _res_cost(_cost)
     {
       // Removing non-zero lower bounds
@@ -199,6 +200,7 @@
                     const SupplyMap &supply ) :
       _graph(graph), _lower(NULL), _capacity(capacity), _cost(cost),
-      _supply(supply), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false), _res_cost(_cost)
+      _supply(supply), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false), _res_graph(NULL),
+      _res_cost(_cost)
     {
       // Checking the sum of supply values
@@ -227,6 +229,7 @@
                     Supply flow_value ) :
       _graph(graph), _lower(&lower), _capacity(graph), _cost(cost),
-      _supply(graph), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false), _res_cost(_cost)
+      _supply(graph), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false), _res_graph(NULL),
+      _res_cost(_cost)
     {
       // Removing non-zero lower bounds
@@ -262,6 +265,7 @@
                     Supply flow_value ) :
       _graph(graph), _lower(NULL), _capacity(capacity), _cost(cost),
-      _supply(graph, 0), _flow(0), _local_flow(false),
-      _potential(0), _local_potential(false), _res_cost(_cost)
+      _supply(graph, 0), _flow(NULL), _local_flow(false),
+      _potential(NULL), _local_potential(false), _res_graph(NULL),
+      _res_cost(_cost)
     {
       _supply[s] =  flow_value;
Index: lemon/network_simplex.h
===================================================================
--- lemon/network_simplex.h	(revision 2619)
+++ lemon/network_simplex.h	(revision 2623)
@@ -32,6 +32,4 @@
 #include <lemon/smart_graph.h>
 #include <lemon/math.h>
-
-#define _DEBUG_
 
 namespace lemon {
@@ -610,5 +608,5 @@
       _pred_edge(_graph), _thread(_graph), _forward(_graph),
       _state(_graph), _red_cost(_graph, _cost, _potential),
-      _flow_result(0), _potential_result(0),
+      _flow_result(NULL), _potential_result(NULL),
       _local_flow(false), _local_potential(false),
       _node_ref(graph), _edge_ref(graph)
@@ -660,5 +658,5 @@
       _pred_edge(_graph), _thread(_graph), _forward(_graph),
       _state(_graph), _red_cost(_graph, _cost, _potential),
-      _flow_result(0), _potential_result(0),
+      _flow_result(NULL), _potential_result(NULL),
       _local_flow(false), _local_potential(false),
       _node_ref(graph), _edge_ref(graph)
@@ -704,5 +702,5 @@
       _pred_edge(_graph), _thread(_graph), _forward(_graph),
       _state(_graph), _red_cost(_graph, _cost, _potential),
-      _flow_result(0), _potential_result(0),
+      _flow_result(NULL), _potential_result(NULL),
       _local_flow(false), _local_potential(false),
       _node_ref(graph), _edge_ref(graph)
@@ -754,5 +752,5 @@
       _pred_edge(_graph), _thread(_graph), _forward(_graph),
       _state(_graph), _red_cost(_graph, _cost, _potential),
-      _flow_result(0), _potential_result(0),
+      _flow_result(NULL), _potential_result(NULL),
       _local_flow(false), _local_potential(false),
       _node_ref(graph), _edge_ref(graph)